NAMEX !MTXr.ROMS.OSramless
org 0
; interrupts are not safe if running with no stack....
DI

; and turn the ctc off just in case
callx CTCoff

;turn of the anoying sound and set up the VDP
callx noSound
callx VDPSetup

; now copy the char map to the vdp so we have something to see when printing
callx setupChars

; now pint the menu screen
.mainMenu
ld a,&F5
callx cls


ld hl,MenuMessage1
ld bc,01
callx print
ld hl,MenuMessage2
ld bc,84
callx print
ld hl,MenuMessage3
ld bc,164
callx print
ld hl,MenuMessage4
ld bc,244
callx print
ld hl,MenuMessage5
ld bc,324
callx print
ld hl,MenuMessage6
ld bc,404
callx print
ld hl,MenuMessage7
ld bc,484
callx print
ld hl,MenuMessage8
ld bc,564
callx print
ld hl,MenuMessage9
ld bc,644
callx print
ld hl,MenuMessageX
ld bc,724
callx print
ld hl,MenuMessage0
ld bc,881
callx print

.mainLoop
callx readKeyboard
jr z mainLoop
cp &31         ; option 1
JP Z stackTest
CP &32         ; option 2
JP Z ram32
CP &33         ; option 3
JP Z ram48 
CP &34         ; option 4
JP z ram16
CP &35         ; option 5
JP z beep
CP &36         ; option 6
JP z RomTest
CP &37         ; option 7
JP z Monitor
CP &1B         ; escape
JP z mainMenu
jr mainLoop

.stackTest
ld a,&F4
callx cls
ld hl,MenuMessage1
ld bc,01
callx print
ld hl,MenuMessage3
ld bc,81
callx print
ld hl,MenuMessageX
ld bc,881
callx print          ;print the escape key message
ld hl,StackMessage1
ld bc,161
callx print
ld hl,StackMessage2
ld bc,241
callx print
ld hl,StackMessage3
ld bc,321
callx print

ld sp,&FD48
ld HL,&AA55
LD DE,&CC33
ld BC,&FF00
PUSH HL
PUSH DE
PUSH BC

ld HL,0
ADD HL,SP
callx printHex

ld hl,StackMessage4
ld bc,401
callx print

ld B,3
.menuLoop
ld a,32
out (1),A
ld a,35
out (1),A
pop hl
callx printHex
DJNZ menuLoop

;loop until esc pressed, then return to the main menu
.loopEsc
callx readKeyboard
CP &1B  
JP z mainMenu
jr loopEsc

.ram32
ld a,&F6
callx cls
ld hl,MenuMessage1
ld bc,01
callx print
ld hl,MenuMessage4
ld bc,81
callx print
ld hl,ram32Message1
ld bc,161
callx print 
ld hl,MenuMessageX
ld bc,881
callx print          ;print the escape key message
LD DE,&80FF
ld a,1
out (0),A            ;Page port to ROM mode pages 0:1
callx clearDE        ;and clear page to zero so memory test can flag reading an incorrect page
ld A,0
out (0),A            ;page port to ROM mode, pages 0:0 the page to be tested

;on entry D is the high byte for the first page to test
;E is the high byte of the first adddres not to test
.MemoryTest
ld bc,244
ld HL,ramMessage2
callx print
ld h,d
ld l,0               ;start address formed in HL
.testLoop
ld a,6               ;screen pointer needs resetting every loop 18 bytes past message start (244 + 18 = 262, =1 x 256 + 6 )
out (2),A
ld a,&5D             ;high byte is 1
out (2),A
callx printHex       ;print HL value doesn't alter HL
ld A,L
XOR H                 
ld (HL),A            ;store "unique" value
ld a,&FD             ;test for the escape key directly
out (5),a            ;row 1, bit 0
in A,(5)
AND 1
jp z mainMenu
inc HL
ld a,H
CP E
jr lo testLoop

ld bc,244
ld HL,ramMessage3
callx print
ld h,d
ld l,0               ;start address formed in HL
.testLoop2
ld a,6               ;screen pointer needs resetting every loop
out (2),A
ld a,&5D             ;high byte is 1
out (2),A
callx printHex       ;print HL value doesn't alter HL
ld a,32
out (1),A            ;print a space
ld A,L
XOR H                ;recreate test value           
XOR (HL)             ;check against the ram
jr nz, fail
;send "Pass" to the screen
ld a,&50
out (1),A
ld a,&61
out (1),A
ld a,&73
out (1),A
ld a,&73
out (1),A
jr testNext

.fail
; send "Fail" to the screen
ld a,&46
out (1),A
ld a,&61
out (1),A
ld a,&69
out (1),A
ld a,&6c
out (1),A
.testNext
ld a,&FD             ;test for the escape key directly
out (5),a            ;row 1, bit 0
in A,(5)
AND 1
jp z mainMenu
inc HL
ld a,H
CP E
jr lo testLoop2
JP memoryTest


.ram48
ld a,&F1
callx cls
ld hl,MenuMessage1
ld bc,01
callx print
ld hl,MenuMessage5
ld bc,81
callx print
ld hl,ram48Message1
ld bc,161
callx print 
ld hl,MenuMessageX
ld bc,881
callx print          ;print the escape key message
ld DE,&40FF
ld a,1
out (0),A            ;Page port to ROM mode pages 0:1
callx clearDE        ;and clear page to zero so memory test can flag reading an incorrect page
ld A,0
out (0),A            ;page port to ROM mode, pages 0:0
JP memoryTest

.ram16
ld a,&FD
callx cls
ld hl,MenuMessage1
ld bc,01
callx print
ld hl,MenuMessage6
ld bc,81
callx print
ld hl,ram16Message1
ld bc,161
callx print 
ld hl,MenuMessageX
ld bc,881
callx print          ;print the escape key message
ld DE,&80C0
ld a,0
out (0),A            ;Page port to ROM mode pages 0:0
callx clearDE        ;and clear page to zero so memory test can flag reading an incorrect page
ld A,1
out (0),A            ;page port to ROM mode, pages 0:1
JP memoryTest

.Beep
ld a,&FC
callx cls
ld hl,MenuMessage1
ld bc,01
callx print
ld hl,MenuMessage7
ld bc,81
callx print
ld hl,MenuMessageX
ld bc,881
callx print          ;print the escape key message

ld HL,tones
ld b,5               ;short "tune"
.beepLoop
ld a,(hl)            ;note data low
and &0f              ;4 bits of frequency
or &80               ;set tone 1
cally sendPSG
ld a,(hl)            ;get the frequency data back
inc hl
ld c,(hl)            ;get the high byte
inc hl               ;shift CA right 4 bits to mask out the 4 bits already sent
sra c
rra
sra c
rra
sra c
rra
sra c
rra
and &3F             ;clear bit 6 and 7
cally sendPSG
LD A,&90            ;ATTENUATION MAX TONE 1
cally sendPSG
ld c,(hl)           ;note length
inc hl
.toneLength
cally delay10       ;destroys A and A'
Dec c
jr nz toneLength
LD A,&9f          ; ATTENUATION OFF TONE 1
cally sendPSG
cally delay10
djnz beepLoop
JP loopEsc

.romTest
ld a,&1A
callx cls
ld hl,MenuMessage1
ld bc,01
callx print
ld hl,MenuMessage8
ld bc,81
callx print
ld hl,MenuMessageX
ld bc,881
callx print          ;print the escape key message
ld hl,romMessage1
ld BC,161
callx print
ld A,&00
out (0),A            ;select rom mode pages 0:0
ld a,241
out (2),A
ld a,&5c
out (2),A
ld HL,&253E
callx fiveRows
ld hl,romMessage2
ld BC,561
callx print
ld A,&10
out (0),A            ;select rom mode pages 1:0
ld a,89
out (2),A
ld a,&5E
out (2),A
ld HL,&2BD0
callx fiveRows

JP loopEsc

;simple monitor based on the one from CPM boot rom
.monitor
ld a,&31
callx cls
ld hl,MenuMessage1
ld bc,01
callx print
ld hl,MenuMessage9
ld bc,41
callx print
ld hl,MonMessage0
ld bc,81
callx print
ld hl,MonMessage1
ld bc,121
callx print
ld hl,MonMessage2
ld bc,161
callx print
ld hl,MenuMessageX
ld bc,201
callx print          ;print the escape key message
.monitorLoop
callx readkeyboard
jr nz monitorloop    ;wait for the last key to go up
callx scrollup
ld BC 920
ld HL,MonMessage3
callx print
.monKeyLoop
callx readKeyboard
jr z monKeyLoop
cp &1B
jp z mainMenu
cp &44           ;"D"
jp z dump
cp &45           ;"E"
jp z edit
cp &46           ;"F"
jp z fill
CP &47           ;"G"
jp z goto

jp monitorLoop

.dump
out (1),A        ;print the D
cally getBC      ;read in a hex address which has to go in BC as that's the only register pair not corrupted.
jp z monitorLoop ;no data input
.dumpRow
ld a,&3A         ; ":"
out (1),a
ld h,8           ;the hex address has been printed on input, so print the contenst of the next 8 locations
ld d,b
ld e,c           ;save the pointer
.dumpBytes
ld a,(bc)
ld l,a
callx printHexL 
ld a,32
out (1),a
ld a,&FD             ;test for the escape key directly
out (5),a            ;row 1, bit 0
in A,(5)
AND 1
jp z monitorLoop
inc BC
dec h
jr nz,dumpBytes
ld h,8
.dumpChar
ld a,(DE)
and &7f
out (1),A
inc de
dec h
jr nz,dumpChar
cally delay10
cally nextLine   ; scoll up, print 2 spaces,copy BC to HL ready for printing 
callx printHex   ; and print the hex address now in HL
jp dumpRow

temph equ 0
templ equ 1

.edit
out (1),A        ;print the E
cally getBC      ;read in a hex address which has to go in BC as that's the only register pair not corrupted.
jp z monitorLoop ;no data input
.editLoop
ld a,&3A
out (1),a        ;print a colon
ld a,c    
store templ
ld a,b
store temph      ;save the address for later
cally getByte    ;read 1 byte into B
jp z monitorLoop :no data so stop input
get templ
ld l,a
get temph
ld h,a
ld (hl),b        ;poke in the data
inc hl           ;and update the pointer
ld b,h           ;move to BC while scrolling
ld c,l
cally nextLine   ;scoll up, print 2 spaces,copy the address back to HL 
callx printHex   ;and print the hex address now in HL
JP editLoop      ;

.fill
out (1),A        ;print the F
cally getBC      ;read in a hex address which has to go in BC as that's the only register pair not corrupted.
jp z monitorLoop ;no data input
ld a,&3A
out (1),a        ;print a colon
ld a,c    
store templ
ld a,b
store temph      ;save the address for later
cally getByte    ;read 1 byte into B
jp z monitorLoop :no data so stop input
get templ
ld l,a
get temph
ld h,a
xor a
.fillLoop
ld (hl),b        ;poke in the data
inc hl
dec a
jr nz fillLoop
JP monitorLoop

.goto
out (1),A        ;print the G
ld a,32
out (1),A        ;print a space
cally getBC      ;read in a hex address which has to go in BC as that's the only register pair not corrupted.
jp z monitorLoop ;no data input
ld h,b
ld l,c
jp (HL)          ;jump to the code and hope the user knows what they're doing!


;first level subroutines, IX has the return address

;scroll the bottom 18 lines of the screen up, and blank the last row
;corrup[ts DE and HL, but BC unaffected

.scrollup
ld hl,&5CF0            ; destination address offset 240 decimal, screen base address &1C00 with bit 14 set for register write
ld de,&1D18            ; source address, offset 280 decimal, bit 14 clear for reads
.scrollLoop
ld a,e                 ;setup the read address
out (2),a
ld a,d
out (2),a
inc de                 ;increment the pointer while allowing the VDP to set up the address
in a,(1)
ex af,af'              ;save the data as A needed to set up the next address
ld a,l                 ;now the write address
out (2),a
ld a,h
out (2),a
inc hl                 ;as withthe read, increment the destination pointer early
ex af,af'              ;get the data back
out (1),A
ld a,h
cp &5F                 ;stop at &5FC0, 960 bytes past the screen start
jr lo scrollLoop
ld a,l
cp &C0
jr lo scrollLoop
ld a,32
ld d,40
.lastRow
out (1),A
dec d
jr nz lastRow
retx

.fiveRows
ld c,5
.frLoop1
ld b,39
.frloop2
ld a,(HL)
and &7F
out (1),A
inc hl
djnz frloop2
ld a,32
out (1),A
dec c
jr nz,frloop1
retx

.CTCoff
ld b,2
.ctc_loop
ld a,3
out (&8),a
out (&9),a
out (&a),a
out (&b),a
djnz ctc_loop
retx

;check A for a valid hex digit, return in A 
.validHex
sub &30                ;deduct the "0" ascii code
CP &0A                 ;was the character "0" to "9" ?
jr lo ValidHex1        ;valid digit, carry is set, so invert on exit
sub &07                ;now check "A" to "F"
cp &07                 ;valid digit has carry set, invalid it's clear, either case it needs inverting then exit
ccf
.validHex1
ccf
.ValidhexDone
retx


; print HL in hex at current screen position
; corrupts A only
.printHex
ld A,H
RRA
RRA
RRA
RRA
cally outhex
ld A,H
cally outHex
.printHexL
ld A,l
RRA
RRA
RRA
RRA
cally outHex
ld A,l
cally outHex          ;can't tail call optimise as rety not the same as retx
retx

.print
ld a,c
out (2),a
ld a,b
add a,&5c
out (2),a
.print_loop
ld a,(HL)
and A
JR Z print_done
out (1),a
inc hl
jr print_loop
.print_done
retx

.cls
out (2),a        ;send the colour data to the VDP
ld a,&87
out (2),A        ;now tell it to update register 7
LD A,0
OUT (2),A
LD A,&5C
OUT (2),A
LD A,32
LD BC,&0004      ;clear the full 1024 to simplufy the scrolling code
.cls_1
OUT (1),A
DJNZ cls_1
DEC C
JR NZ cls_1
retx

;kill the sound
.noSound
Ld hl,soundData
ld b,12
.soundLoop
ld a,(hl)
cally sendPSG
inc hl
DJNZ soundLoop
retx

;VDP set up for text mode as used by MTX Basic, character 
;definitions are at 1800 and the screen at 1C00

.VDPSetup
LD B,8
LD C,&80
LD HL,VDPTable
.vdp_1
LD A,(HL)
OUT (2),A
LD A,C
OUT (2),A
INC C
INC HL
DJNZ vdp_1
retx

.setupChars
LD A,0
OUT (2),A
LD A,&58
OUT (2),A
LD BC,&400
LD HL,charTable
.charLoop
ld a,(hl)
inc hl
out (1),A
dec bc
ld a,b
or c
jr nz,charLoop
retx

;retruns the first key found - in the main bank only no shift or control decoded
;corrupts DE HL
.ReadKeyboard
LD H,&08       ;H=8=DRIVE COUNTER
xor a          ;a=0 reset carry
ld l,a         ;needed later
ld d,a
dec a          ;a=ff,carry still clear
.scan2
rla            ;A=FE,FD,FB,F7,EF,DF,BF,7F
out (5),a      ;sent to keyboard hardware
ld e,a         ;save the drive line data        
in a,(5)       ;read the main bank of keys
CP &FF         ;anything pressed ?
JR nz,keydown  ;move on to decode
ld a,e         ;get the drive line data back
dec h
JR NZ  scan2   ;loop for all 8 drive lines
;nothing pressed in the main bank, so test for the space bar on port 6
;LD A,&7F      ;port 5 already set to these values on exit above
;OUT (5),A
IN A,(6)
AND 1          ;space bar is bit 0
xor 1          ;invert so bit 1 set now if space was pressed, A zero otherwise
rrca           ;&80 or &00
rrca           ;&40 or &00
rrca           ;&20 or &00           
.onekey
and A          ;If the keyboard table returned a valid key A will be non zero
retx

;one or more keys pressed in the main bank of 8 search for low bits in A
;since A is holding the scan line data, build the key code in H
.keyDown
dec h          ;drive count is 1-8 adjust to 0-7, L already set to zero  
add hl,hl
add hl,hl
add hl,hl      ;H is now 8x the drive counter
.keyDown1
rra            ;shift out the low bit
jr nc keyFound ;a zero into carry so that drive line was low
inc h          ;update the counter
jr keyDown1    ;and test the next bit 

; entered with H holding the line number that was low plus 8 x the row count
.keyfound
ld e,h         ;E is already zero so DE is now an index into the table
LD HL,keytable
add HL,DE
ld A,(HL)
jr onekey

;clear memory in advance of ram test
.clearDE
ld h,d
ld l,0               ;start address formed in HL
.clearLoop
ld (hl),0
inc HL
ld a,h
CP E
jr lo clearLoop
retx

; second level subroutines use rety to exit
;all routines corrupt A register

;send 1 hex digit in the low nibble of A to the screen
.outHex
and &0f
add A,48
cp 58
JR lo, noadd
add A,7
.noadd
out (1),a
rety

;0.1 sec delay = 400,000 cycles, at 4mhs Corrupts A' as well as A
; inner loop 255x 16 + 11= 4091
; outer loop 97 x (28+4091) =399543 close enough
.delay10
LD A,97        
.delayLoop1
ex af,af'        ;4 
xor A            ;4
.delayLoop2
dec a                ; 4
jr NZ delayLoop2     ; 12
ex af,af'        ;4
dec a            ;4
jr NZ delayLoop1     ; 12
rety

;send data to the PSG, call and return time will ensure the 32 us setup time is met
.sendPSG
OUT (6),A
IN A,(3)
rety

;read address to BC and read byte to B both need to call read keyboard so they have to be
;IY called to avoid corrupting the "stack" there's a lot of repeated due to the same 
;stack limitations

.getBC
ld BC,0
.waitnokey1
callx readkeyboard
jr nz,waitnokey1    ;wait for the last key to go up
.GetBCwaitKey1
callx readKeyboard
jp z getBCWaitKey1
cp &1B
jp z invalid1       ;escape aborts
ld L,A              ;save the ascii code
callx validHex      ;sets C if the character isn't valid Hex
jp C invalid1
ld C,A              ;save the first nibble in C
ld a,L
out (1),A           ;get the character back for printing
.waitnokey2
callx readkeyboard
jr nz,waitnokey2    ;wait for the last key to go up
.GetBCwaitKey2
callx readKeyboard
jp z getBCWaitKey2
cp &1B
jp z invalid1       ;escape aborts
ld L,A              ;save the ascii code
callx validHex      ;sets C if the character isn't valid Hex
jp C validBC
sla c               ;this is the 2nd digit so shift C 4 places
sla c
sla c
sla c
or C                ;combine the rotated value with A
ld c,a              ;and save back in C
ld a,L
out (1),A
.waitnokey3
callx readkeyboard
jr nz,waitnokey3    ;wait for the last key to go up
.GetBCwaitKey3
callx readKeyboard
jp z getBCWaitKey3
cp &1B
jp z invalid1       ;anything less than "0" ends input
ld L,A              ;save the ascii code
callx validHex      ;sets C if the character isn't valid Hex
jr C validBC
sla c               ;this is the 3nd digit so shift C 4 places
rl b                ;and rotate the 3rd digit in B
sla c
rl b
sla c
rl b
sla c
rl b
or C                ;combine the rotated value with A
ld c,a              ;and save back in C
ld a,L
out (1),a
.waitnokey4
callx readkeyboard
jr nz,waitnokey4    ;wait for the last key to go up
.GetBCwaitKey4
callx readKeyboard
jp z getBCWaitKey4
cp &1B
jr z invalid1  
ld L,A              ;save the ascii code
callx validHex      ;sets C if the character isn't valid Hex
jr C validBC
sla c               ;this is the final digit so shift C 4 places
rl b                ;and rotate the 3rd and 4th digit in B
sla c
rl b
sla c
rl b
sla c
rl b
or C                ;combine the rotated value with A
ld c,a              ;and save back in C
ld a,l
out (1),a
.validBC
inc A               ;make sure Z isn't set
rety

.getbyte
ld B,0
.waitnokey5
callx readkeyboard
jr nz,waitnokey5    ;wait for the last key to go up
.GetBytewaitKey1
callx readKeyboard
jp z getByteWaitKey1
cp 1B
jp z invalid1       ;escape aborts
ld L,A              ;save the ascii code
callx validHex      ;sets C if the character isn't valid Hex
jp C invalid1
ld B,A              ;save the first nibble in B
ld a,l
out (1),a
.waitnokey6
callx readkeyboard
jr nz,waitnokey6    ;wait for the last key to go up
.GetBytewaitKey2
callx readKeyboard
jp z getByteWaitKey2
cp &1B
jr z invalid1  
ld L,A              ;save the ascii code
callx validHex      ;sets C if the character isn't valid Hex
jr C validByte
sla b               ;this is the 2nd digit so shift B 4 places
sla b
sla b
sla b
or b                ;combine the rotated value with A
ld b,a              ;and save back in B
ld a,l
out (1),a
.ValidByte
inc A               ;make sure Z isn't set
rety

.invalid1
xor A               ;set the Z flag
rety

.nextLine
callx scrollup       ;will corrupt DE and HL, but not BC
ld a,154             ;set the screen pointer ready to output at offset 922 
out (2),a
ld a,&5F
out (2),a
ld h,b
ld l,c
rety

; fixed data area grouped together for neatness

.MenuMessage1
DS "Memotech Test Rom Build "
BUILD
DB 0

.MenuMessage2
DZ "Test Options"

.MenuMessage3
DZ "1: Stack Test"
.MenuMessage4
DZ "2: 32k memory test for MTX500"
.MenuMessage5
DZ "3: 48K main memory test for MTX512"
.MenuMessage6
DZ "4: 16k paged memory test for MTX512"
.MenuMessage7
DZ "5: Sound Test"
.MenuMessage8
DZ "6: Page Rom Test"
.MenuMessage9
DZ "7: Simple Monitor"
.MenuMessageX
DZ "Esc returns to main menu"

.MenuMessage0
DZ "NB Working ram is optional!"

.StackMessage1
DZ "Stack pointer set to #FD48"
.StackMessage2
DZ "Test values pushed #AA55 #CC33 #FF00"
.StackMessage3
DZ "new stack pointer value #"
.StackMessage4
DZ "Test values pulled"

.ram32Message1
DZ "Testing page 0 ram from #8000 to #FEFF"

.ram48Message1
DZ "Testing page 0 ram from #4000 to #FEFF"

.ram16Message1
DZ "Testing page 1 ram from #8000 to #BFFF"

.ramMessage2
DZ "Writing location #     ---- "

.ramMessage3
DZ "Reading location #"

.ROMmessage1
DZ "Printing Keyword table from ROM 0"
.ROMmessage2
DZ "Printing hidden message in ROM 1"

.monMessage0
DZ   "Options:"
.monMessage1
DZ   "D Memory Dump      E Memory Edit"
.monMessage2
DZ   "F fill 256 bytes   G Go"
.monMessage3
DZ   ">"


;upper case keyboard table for main bank only
; "special" keys return a zero
.Keytable
DB &5A,&43,&42,&4D,&2E,&5F,&30,&0D       ;Drive line 7   Z  C B M . _ kp0 kpRET 
DB &00,&58,&56,&4E,&2C,&2F,&00,&2E       ;Drive line 6  Lsh X V N , / Rsh  kp.  
DB &41,&44,&47,&4A,&4C,&3A,&0D,&32       ;Drive line 5   A  D G J L : ret  kp2 
DB &00,&53,&46,&48,&4B,&3B,&5D,&33       ;Drive line 4  cap S F H K ;  ]   kk3  
DB &51,&45,&54,&55,&4F,&40,&0A,&31       ;Drive line 3   Q  E T U O @ LF   kp1 
DB &00,&57,&52,&59,&49,&50,&5B,&35       ;Drive line 2 ctrl W R Y I P  [   kp5  
DB &1B,&32,&34,&36,&38,&30,&5E,&35       ;Drive line 1 esc  2 4 6 8 0  ^   kp8  
DB &31,&33,&35,&37,&39,&2D,&5C,&37       ;Drive line 0   1  3 5 7 9 -  \   kp7  

;data to mute the PSG
.soundData
db &80,00    ;Channel 0, frequency 0
db &9f       ;channel 0, attenuation off
db &A0,00    ;Channel 1, frequency 0
db &Bf       ;channel 1, attenuation off
db &C0,00    ;Channel 2, frequency 0
db &Df       ;channel 2, attenuation off
db &Ff       ;channel 3, attenuation off
db &E0,00    ;Channel 3, periodic noise N/512

.TONES
DW 319
DB 6
DW 284
DB 6
DW 358
DB 6
DW 716
DB 6
DW 478
DB 10

;text mode screen set up data
.vdpTable
DB &00,&D0,&07,&00,&03,&7E,&07,&FC

org &1C00

.charTable
;control characters
DB &8F,&77,&47,&57,&47,&7F,&87,&FF
DB &DF,&AF,&77,&77,&07,&77,&77,&FF
DB &0F,&77,&77,&0F,&77,&77,&0F,&FF
DB &8F,&77,&7F,&7F,&7F,&77,&8F,&FF
DB &0F,&77,&77,&77,&77,&77,&0F,&FF
DB &07,&7F,&7F,&0F,&7F,&7F,&07,&FF
DB &07,&7F,&7F,&0F,&7F,&7F,&7F,&FF
DB &8F,&77,&7F,&47,&77,&77,&8F,&FF
DB &77,&77,&77,&07,&77,&77,&77,&FF
DB &8F,&DF,&DF,&DF,&DF,&DF,&8F,&FF
DB &87,&EF,&EF,&EF,&6F,&6F,&9F,&FF
DB &77,&6F,&5F,&3F,&5F,&6F,&77,&FF
DB &7F,&7F,&7F,&7F,&7F,&7F,&07,&FF
DB &77,&27,&57,&57,&77,&77,&77,&FF
DB &77,&77,&37,&57,&67,&77,&77,&FF
DB &8F,&77,&77,&77,&77,&77,&8F,&FF
DB &0F,&77,&77,&0F,&7F,&7F,&7F,&FF
DB &8F,&77,&77,&77,&57,&6F,&97,&FF
DB &0F,&77,&77,&0F,&5F,&6F,&77,&FF
DB &8F,&77,&7F,&8F,&F7,&77,&8F,&FF
DB &07,&DF,&DF,&DF,&DF,&DF,&DF,&FF
DB &77,&77,&77,&77,&77,&77,&8F,&FF
DB &77,&77,&77,&77,&AF,&AF,&DF,&FF
DB &77,&77,&77,&57,&57,&57,&AF,&FF
DB &77,&77,&AF,&DF,&AF,&77,&77,&FF
DB &77,&77,&AF,&DF,&DF,&DF,&DF,&FF
DB &07,&F7,&EF,&DF,&BF,&7F,&07,&FF
DB &8F,&BF,&BF,&BF,&BF,&BF,&8F,&FF
DB &7F,&7F,&BF,&DF,&EF,&F7,&F7,&FF
DB &8F,&EF,&EF,&EF,&EF,&EF,&8F,&FF
DB &DF,&AF,&77,&FF,&FF,&FF,&FF,&FF
DB &FF,&FF,&FF,&FF,&FF,&FF,&07,&FF


;regular MTX ASCII
DB &00,&00,&00,&00,&00,&00,&00,&00
DB &20,&20,&20,&20,&00,&00,&20,&00
DB &50,&50,&50,&00,&00,&00,&00,&00
DB &50,&50,&F8,&50,&F8,&50,&50,&00
DB &20,&78,&A0,&70,&28,&F0,&20,&00
DB &C8,&C8,&10,&20,&40,&98,&98,&00
DB &40,&A0,&A0,&40,&A8,&90,&68,&00
DB &60,&20,&40,&00,&00,&00,&00,&00
DB &10,&20,&40,&40,&40,&20,&10,&00
DB &40,&20,&10,&10,&10,&20,&40,&00
DB &00,&A8,&70,&F8,&70,&A8,&00,&00
DB &00,&20,&20,&F8,&20,&20,&00,&00
DB &00,&00,&00,&60,&60,&20,&40,&00
DB &00,&00,&00,&F8,&00,&00,&00,&00
DB &00,&00,&00,&00,&60,&60,&00,&00
DB &08,&08,&10,&20,&40,&80,&80,&00
DB &20,&50,&88,&88,&88,&50,&20,&00
DB &20,&60,&20,&20,&20,&20,&70,&00
DB &70,&88,&08,&10,&20,&40,&F8,&00
DB &F8,&10,&20,&10,&08,&88,&70,&00
DB &10,&30,&50,&90,&90,&F8,&10,&00
DB &F8,&80,&F0,&08,&08,&88,&70,&00
DB &70,&80,&80,&F0,&88,&88,&70,&00
DB &F8,&08,&08,&10,&20,&40,&40,&00
DB &70,&88,&88,&70,&88,&88,&70,&00
DB &70,&88,&88,&78,&08,&08,&70,&00
DB &00,&00,&60,&60,&00,&60,&60,&00
DB &00,&60,&60,&00,&60,&60,&20,&40
DB &10,&20,&40,&80,&40,&20,&10,&00
DB &00,&00,&F8,&00,&F8,&00,&00,&00
DB &40,&20,&10,&08,&10,&20,&40,&00
DB &70,&88,&08,&10,&20,&00,&20,&00
DB &70,&88,&B8,&A8,&B8,&80,&78,&00
DB &20,&50,&88,&88,&F8,&88,&88,&00
DB &F0,&88,&88,&F0,&88,&88,&F0,&00
DB &70,&88,&80,&80,&80,&88,&70,&00
DB &F0,&88,&88,&88,&88,&88,&F0,&00
DB &F8,&80,&80,&F0,&80,&80,&F8,&00
DB &F8,&80,&80,&F0,&80,&80,&80,&00
DB &70,&88,&80,&B8,&88,&88,&70,&00
DB &88,&88,&88,&F8,&88,&88,&88,&00
DB &70,&20,&20,&20,&20,&20,&70,&00
DB &78,&10,&10,&10,&90,&90,&60,&00
DB &88,&90,&A0,&C0,&A0,&90,&88,&00
DB &80,&80,&80,&80,&80,&80,&F8,&00
DB &88,&D8,&A8,&A8,&88,&88,&88,&00
DB &88,&88,&C8,&A8,&98,&88,&88,&00
DB &70,&88,&88,&88,&88,&88,&70,&00
DB &F0,&88,&88,&F0,&80,&80,&80,&00
DB &70,&88,&88,&88,&A8,&90,&68,&00
DB &F0,&88,&88,&F0,&A0,&90,&88,&00
DB &70,&88,&80,&70,&08,&88,&70,&00
DB &F8,&20,&20,&20,&20,&20,&20,&00
DB &88,&88,&88,&88,&88,&88,&70,&00
DB &88,&88,&88,&88,&50,&50,&20,&00
DB &88,&88,&88,&A8,&A8,&A8,&50,&00
DB &88,&88,&50,&20,&50,&88,&88,&00
DB &88,&88,&50,&20,&20,&20,&20,&00
DB &F8,&08,&10,&20,&40,&80,&F8,&00
DB &70,&40,&40,&40,&40,&40,&70,&00
DB &80,&80,&40,&20,&10,&08,&08,&00
DB &70,&10,&10,&10,&10,&10,&70,&00
DB &20,&50,&88,&00,&00,&00,&00,&00
DB &00,&00,&00,&00,&00,&00,&F8,&00
DB &30,&20,&10,&00,&00,&00,&00,&00
DB &00,&00,&60,&10,&70,&90,&78,&00
DB &80,&80,&E0,&90,&90,&90,&E0,&00
DB &00,&00,&70,&80,&80,&80,&70,&00
DB &10,&10,&70,&90,&90,&90,&78,&00
DB &00,&00,&70,&88,&F8,&80,&78,&00
DB &30,&40,&40,&E0,&40,&40,&40,&00
DB &00,&00,&78,&88,&78,&08,&88,&70
DB &80,&80,&E0,&90,&90,&90,&90,&00
DB &20,&00,&60,&20,&20,&20,&70,&00
DB &20,&00,&60,&20,&20,&20,&20,&C0
DB &80,&80,&90,&A0,&C0,&A0,&90,&00
DB &60,&20,&20,&20,&20,&20,&70,&00
DB &00,&00,&50,&A8,&A8,&A8,&A8,&00
DB &00,&00,&E0,&90,&90,&90,&90,&00
DB &00,&00,&70,&88,&88,&88,&70,&00
DB &00,&00,&E0,&90,&90,&E0,&80,&80
DB &00,&00,&38,&48,&48,&38,&08,&08
DB &00,&00,&B0,&C0,&80,&80,&80,&00
DB &00,&00,&70,&80,&70,&08,&F0,&00
DB &40,&40,&F0,&40,&40,&40,&30,&00
DB &00,&00,&90,&90,&90,&90,&68,&00
DB &00,&00,&88,&88,&50,&20,&20,&00
DB &00,&00,&88,&88,&A8,&A8,&50,&00
DB &00,&00,&88,&50,&20,&50,&88,&00
DB &00,&00,&48,&48,&48,&38,&08,&70
DB &00,&00,&F8,&10,&20,&40,&F8,&00
DB &18,&20,&20,&40,&20,&20,&18,&00
DB &20,&20,&20,&20,&20,&20,&20,&20
DB &C0,&20,&20,&10,&20,&20,&C0,&00
DB &48,&A8,&90,&00,&00,&00,&00,&00
DB &F8,&F8,&F8,&F8,&F8,&F8,&F8,&F8



END